@echo off
set COB_LIBRARY_PATH=.;%COB_LIBRARY_PATH%
echo BINARY: 2-4-8 big-endian
copy /y binary.1 test.conf > nul
copy /y binary.2 dump.c > nul
cl /LD dump.c > comp.out 2>&1
if errorlevel 1 goto err
sed -e "s/@USAGE@/BINARY/" numeric-dump.cob > prog.cob
if errorlevel 1 goto err
cobc -x -conf=test.conf -debug -Wall -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff binary.3 result
if errorlevel 1 goto err

sed -e "s/@USAGE@/BINARY/" numeric-display.cob > prog.cob
if errorlevel 1 goto err
cobc -x -conf=test.conf -debug -Wall -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff binary.4 result
if errorlevel 1 goto err

echo BINARY: 2-4-8 native
copy /y binary.5 test.conf > nul
sed -e "s/@USAGE@/BINARY/" numeric-dump.cob > prog.cob
if errorlevel 1 goto err
cobc -x -conf=test.conf -debug -Wall -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff binary.6 result
if errorlevel 1 goto err

sed -e "s/@USAGE@/BINARY/" numeric-display.cob > prog.cob
if errorlevel 1 goto err
cobc -x -conf=test.conf -debug -Wall -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff binary.7 result
if errorlevel 1 goto err

echo BINARY: 1-2-4-8 big-endian
copy /y binary.8 test.conf > nul
sed -e "s/@USAGE@/BINARY/" numeric-dump.cob > prog.cob
if errorlevel 1 goto err
cobc -x -conf=test.conf -debug -Wall -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff binary.9 result
if errorlevel 1 goto err
sed -e "s/@USAGE@/BINARY/" numeric-display.cob > prog.cob
if errorlevel 1 goto err
cobc -x -conf=test.conf -debug -Wall -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff binary.10 result
if errorlevel 1 goto err

echo BINARY: 1-2-4-8 native
copy /y binary.11 test.conf > nul
sed -e "s/@USAGE@/BINARY/" numeric-dump.cob > prog.cob
if errorlevel 1 goto err
cobc -x -conf=test.conf -debug -Wall -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff binary.12 result
if errorlevel 1 goto err
sed -e "s/@USAGE@/BINARY/" numeric-display.cob > prog.cob
if errorlevel 1 goto err
cobc -x -conf=test.conf -debug -Wall -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff binary.13 result
if errorlevel 1 goto err

echo BINARY: 1--8 big-endian
copy /y binary.14 test.conf > nul
sed -e "s/@USAGE@/BINARY/" numeric-dump.cob > prog.cob
if errorlevel 1 goto err
cobc -x -conf=test.conf -debug -Wall -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff binary.15 result
if errorlevel 1 goto err
sed -e "s/@USAGE@/BINARY/" numeric-display.cob > prog.cob
if errorlevel 1 goto err
cobc -x -conf=test.conf -debug -Wall -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff binary.16 result
if errorlevel 1 goto err


echo BINARY: 1--8 native
copy /y binary.17 test.conf > nul
sed -e "s/@USAGE@/BINARY/" numeric-dump.cob > prog.cob
if errorlevel 1 goto err
cobc -x -conf=test.conf -debug -Wall -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff binary.18 result
if errorlevel 1 goto err
sed -e "s/@USAGE@/BINARY/" numeric-display.cob > prog.cob
if errorlevel 1 goto err
cobc -x -conf=test.conf -debug -Wall -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff binary.19 result
if errorlevel 1 goto err

echo BINARY: full-print
copy /y binary.20 test.conf > nul
sed -e "s/@USAGE@/BINARY/" numeric-display.cob > prog.cob
if errorlevel 1 goto err
cobc -x -conf=test.conf -debug -Wall -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff binary.21 result
if errorlevel 1 goto err
echo BINARY TEST PASSED
del test.conf dump.* prog.* result comp.out
goto end

:err
	echo BINARY TEST FAILED
	pause
:end
