@echo off
set COB_LIBRARY_PATH=.;%COB_LIBRARY_PATH%
echo MISC TEST GROUP

del /q prog.cob > nul 2>&1
echo Source file not found
cobc -C -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if not errorlevel 1 goto err
diff misc.0 comp.out
if errorlevel 1 goto err

echo Comma separator without space
copy /y misc.1 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.2 result
if errorlevel 1 goto err

echo LOCAL-STORAGE
copy /y misc.3 callee.cob > nul
cobc -m -debug -Wall -std=cobol2002 callee.cob > comp.out 2>&1
if errorlevel 1 goto err
copy /y misc.4 caller.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog caller.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.5 result
if errorlevel 1 goto err

echo EXTERNAL data item
copy /y misc.6 callee.cob > nul
cobc -m -debug -Wall -std=cobol2002 callee.cob > comp.out 2>&1
if errorlevel 1 goto err
copy /y misc.7 caller.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog caller.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.8 result
if errorlevel 1 goto err

echo EXTERNAL AS data item
copy /y misc.9 callee.cob > nul
cobc -m -debug -Wall -std=cobol2002 callee.cob > comp.out 2>&1
if errorlevel 1 goto err
copy /y misc.10 caller.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog caller.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.11 result
if errorlevel 1 goto err

echo cobcrun validation
copy /y misc.12 callee.cob > nul
cobc -m -debug -Wall -std=cobol2002 callee.cob > comp.out 2>&1
if errorlevel 1 goto err
copy /y misc.13 caller.cob > nul
cobc -m -debug -Wall -std=cobol2002 caller.cob > comp.out 2>&1
if errorlevel 1 goto err
cobcrun caller > result
if errorlevel 1 goto err
diff misc.14 result
if errorlevel 1 goto err

echo MOVE to itself
copy /y misc.15 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.16 result
if errorlevel 1 goto err

echo MOVE with refmod
copy /y misc.17 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.18 result
if errorlevel 1 goto err

echo MOVE with refmod (variable)
copy /y misc.19 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.20 result
if errorlevel 1 goto err

echo MOVE with group refmod
copy /y misc.21 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.22 result
if errorlevel 1 goto err

echo MOVE indexes
copy /y misc.23 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.24 result
if errorlevel 1 goto err

echo MOVE X'00'
copy /y misc.25 dump.c > nul
cl /LD dump.c > comp.out 2>&1
if errorlevel 1 goto err
copy /y misc.26 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.27 result
if errorlevel 1 goto err

echo Level 01 subscripts
copy /y misc.28 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if not errorlevel 1 goto err
diff misc.29 comp.out
if errorlevel 1 goto err

echo Class check with reference modification
copy /y misc.30 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.31 result
if errorlevel 1 goto err

echo Index and parenthesized expression
copy /y misc.32 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err

echo Alphanumeric and binary numeric
copy /y misc.33 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.34 result
if errorlevel 1 goto err

echo Dynamic call with static linking
copy /y misc.35 callee.cob > nul
cobc -c -m -debug -Wall -std=cobol2002 callee.cob > comp.out 2>&1
if errorlevel 1 goto err
copy /y misc.36 caller.cob > nul
cobc -c -x -debug -Wall -std=cobol2002 caller.cob > comp.out 2>&1
if errorlevel 1 goto err
cobc -x -o prog caller.obj callee.obj > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.37 result
if errorlevel 1 goto err

echo CALL m1. CALL m2. CALL m1.
copy /y misc.38 m1.cob > nul
cobc -m -debug -Wall -std=cobol2002 m1.cob > comp.out 2>&1
if errorlevel 1 goto err
copy /y misc.39 m2.cob > nul
cobc -m -debug -Wall -std=cobol2002 m2.cob > comp.out 2>&1
if errorlevel 1 goto err
copy /y misc.40 caller.cob > nul
cobc -x -debug -Wall -std=cobol2002 caller.cob > comp.out 2>&1
if errorlevel 1 goto err
caller > result
if errorlevel 1 goto err
diff misc.41 result
if errorlevel 1 goto err

echo CALL: binary literal parameter/LENGTH OF
copy /y misc.42 test.conf > nul
copy /y misc.43 dump.c > nul
copy /y misc.44 prog.cob > nul
cobc -m -debug -Wall -std=cobol2002 dump.c > comp.out 2>&1
if errorlevel 1 goto err
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.45 result
if errorlevel 1 goto err
cobc -x -debug -Wall -conf=test.conf prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.45 result
if errorlevel 1 goto err

echo INSPECT REPLACING LEADING ZEROS BY SPACES
copy /y misc.46 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.47 result
if errorlevel 1 goto err

echo INSPECT: no repeat conversion check
copy /y misc.48 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.49 result
if errorlevel 1 goto err

echo INSPECT: TALLYING BEFORE
copy /y misc.50 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.51 result
if errorlevel 1 goto err

echo INSPECT: TALLYING AFTER
copy /y misc.52 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.53 result
if errorlevel 1 goto err

echo INSPECT REPLACING TRAILING ZEROS BY SPACES
copy /y misc.54 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.55 result
if errorlevel 1 goto err

echo SWITCHES
set COB_SWITCH_1=ON
set COB_SWITCH_2=OFF
copy /y misc.56 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.57 result
if errorlevel 1 goto err
set COB_SWITCH_1=
set COB_SWITCH_2=

echo Nested PERFORM
copy /y misc.58 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.59 result
if errorlevel 1 goto err

echo EXIT PERFORM
copy /y misc.60 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.61 result
if errorlevel 1 goto err

echo EXIT PERFORM CYCLE
copy /y misc.62 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.63 result
if errorlevel 1 goto err

echo 88 with FILLER
copy /y misc.64 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.65 result
if errorlevel 1 goto err

echo non-overflow after overflow
copy /y misc.66 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.67 result
if errorlevel 1 goto err

echo PERFORM ... CONTINUE
copy /y misc.68 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err

echo STRING with subscript reference
copy /y misc.69 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.70 result
if errorlevel 1 goto err

echo UNSTRING DELIMITED ALL LOW-VALUE
copy /y misc.71 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.72 result
if errorlevel 1 goto err

echo READ INTO AT-END sequence
copy /y misc.73 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.74 result
if errorlevel 1 goto err

echo First READ on empty SEQUENTIAL INDEXED file
copy /y misc.75 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.76 result
if errorlevel 1 goto err

echo REWRITE a RELATIVE file with RANDOM access
copy /y misc.77 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.78 result
if errorlevel 1 goto err

echo SORT: table sort
copy /y misc.79 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.80 result
if errorlevel 1 goto err

echo SORT: EBCDIC table sort
copy /y misc.81 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.82 result
if errorlevel 1 goto err

echo SORT nonexistent file
copy /y misc.83 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
if not exist SORT-OUT goto err
del SORT-OUT

echo PIC ZZZ-, ZZZ+
copy /y misc.84 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.85 result
if errorlevel 1 goto err

echo Larger REDEFINES lengths
copy /y misc.86 prog.cob > nul
cobc -C -x -debug -Wall -std=mf prog.cob > comp.out 2>&1
if errorlevel 1 goto err
diff misc.87 comp.out
if errorlevel 1 goto err
cobc -x -debug -Wall -std=mf prog.c > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.88 result
if errorlevel 1 goto err

echo PERFORM type OSVS
copy /y misc.89 test.conf > nul
copy /y misc.90 prog.cob > nul
cobc -x -debug -Wall -conf=test.conf prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.91 result
if errorlevel 1 goto err

echo Sticky LINKAGE
copy /y misc.92 test.conf > nul
copy /y misc.93 callee.cob > nul
copy /y misc.94 caller.cob > nul
cobc -m -debug -Wall -conf=test.conf callee.cob > comp.out 2>&1
if errorlevel 1 goto err
cobc -x -debug -Wall -conf=test.conf caller.cob > comp.out 2>&1
if errorlevel 1 goto err
caller > result
if errorlevel 1 goto err
diff misc.95 result
if errorlevel 1 goto err

echo COB_PRE_LOAD
copy /y misc.96 callee.cob > nul
copy /y misc.97 caller.cob > nul
cobc -m -debug -Wall -std=cobol2002 callee.cob > comp.out 2>&1
if errorlevel 1 goto err
cobc -x -debug -Wall -std=cobol2002 caller.cob > comp.out 2>&1
if errorlevel 1 goto err
set COB_PRE_LOAD=callee
caller > result
if errorlevel 1 goto err
diff misc.98 result
if errorlevel 1 goto err

echo 88 level with FALSE IS clause
copy /y misc.99 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff misc.100 result
if errorlevel 1 goto err

echo MISC TEST PASSED
del test.conf m1.* m2.* TEST-FILE dump.* caller.* callee.* prog.* result comp.out
goto end

:err
	echo MISC TEST FAILED
	pause
:end
